package betterwithmods.common.blocks.mechanical;

import betterwithmods.api.block.IMechanicalBlock;
import betterwithmods.common.BWMBlocks;
import betterwithmods.common.BWMItems;
import betterwithmods.common.BWSounds;
import betterwithmods.common.blocks.BlockRotate;
import betterwithmods.util.DirUtils;
import betterwithmods.util.InvUtils;
import betterwithmods.util.MechanicalUtil;
import net.minecraft.block.Block;
import net.minecraft.block.SoundType;
import net.minecraft.block.material.Material;
import net.minecraft.block.properties.PropertyBool;
import net.minecraft.block.state.BlockStateContainer;
import net.minecraft.block.state.IBlockState;
import net.minecraft.entity.Entity;
import net.minecraft.entity.EntityLivingBase;
import net.minecraft.entity.item.EntityItem;
import net.minecraft.init.Blocks;
import net.minecraft.init.SoundEvents;
import net.minecraft.item.ItemStack;
import net.minecraft.util.EnumFacing;
import net.minecraft.util.EnumHand;
import net.minecraft.util.SoundCategory;
import net.minecraft.util.math.AxisAlignedBB;
import net.minecraft.util.math.BlockPos;
import net.minecraft.world.IBlockAccess;
import net.minecraft.world.World;

import java.util.List;
import java.util.Random;

public class BlockBellows extends BlockRotate implements IMechanicalBlock {
    public static final PropertyBool ACTIVE = PropertyBool.func_177716_a("active");
    public static final PropertyBool TRIGGER = PropertyBool.func_177716_a("trigger");

    public BlockBellows() {
        super(Material.field_151575_d);
        this.func_149675_a(true);
        this.func_149711_c(2.0F);
        this.func_180632_j(this.field_176227_L.func_177621_b().func_177226_a(DirUtils.HORIZONTAL, EnumFacing.SOUTH)
                .func_177226_a(ACTIVE, false).func_177226_a(TRIGGER, false));
        this.func_149672_a(SoundType.field_185848_a);
    }

    @Override
    public int func_149738_a(World world) {
        return 37;
    }

    @Override
    public void nextState(World world, BlockPos pos, IBlockState state) {
        world.func_175656_a(pos, state.func_177231_a(DirUtils.HORIZONTAL).func_177226_a(ACTIVE, false));
    }

    @Override
    public boolean func_149662_c(IBlockState state) {
        return state.func_177230_c() == this && !state.func_177229_b(ACTIVE);
    }

    @Override
    public boolean func_149686_d(IBlockState state) {
        return state.func_177230_c() == this && !state.func_177229_b(ACTIVE);
    }

    @Deprecated
    @Override
    public IBlockState getStateForPlacement(World world, BlockPos pos, EnumFacing side, float flX, float flY, float flZ,
                                            int meta, EntityLivingBase living, EnumHand hand) {
        IBlockState state = super.getStateForPlacement(world, pos, side, flX, flY, flZ, meta, living, hand);
        return setFacingInBlock(state, living.func_174811_aO());
    }

    @Override
    public IBlockState setFacingInBlock(IBlockState state, EnumFacing facing) {
        return state.func_177226_a(DirUtils.HORIZONTAL, facing);
    }

    @Override
    public EnumFacing getFacingFromBlockState(IBlockState state) {
        return state.func_177229_b(DirUtils.HORIZONTAL);
    }

    @Override
    public void func_180633_a(World world, BlockPos pos, IBlockState state, EntityLivingBase entity,
                                ItemStack stack) {
        if (entity == null)
            setFacingInBlock(state, EnumFacing.NORTH);
        EnumFacing facing = DirUtils.convertEntityOrientationToFlatFacing(entity);
        setFacingInBlock(state, facing);
        world.func_180497_b(pos, this, 10, 5);
    }

    @Override
    public AxisAlignedBB func_185496_a(IBlockState state, IBlockAccess world, BlockPos pos) {
        if (state.func_177229_b(ACTIVE))
            return new AxisAlignedBB(0.0F, 0.0F, 0.0F, 1.0F, 0.6875F, 1.0F);
        return field_185505_j;
    }

    @Override
    public void func_189540_a(IBlockState state, World world, BlockPos pos, Block block, BlockPos other) {
        if (!isCurrentStateValid(world, pos)) {
            world.func_180497_b(pos, this, func_149738_a(world), 5);
            setTriggerMechanicalStateChange(world, pos, true);
        } else {
            boolean continuous = isTriggerMechanicalStateChange(world, pos);

            if (continuous) {
                if (isCurrentStateValid(world, pos)) {
                    setTriggerMechanicalStateChange(world, pos, false);
                }
            }
        }
    }

    public boolean isCurrentStateValid(World world, BlockPos pos) {
        boolean gettingPower = isInputtingMechPower(world, pos);
        boolean mechanicalOn = isMechanicalOn(world, pos);

        return gettingPower == mechanicalOn;
    }

    @Override
    public void func_180650_b(World world, BlockPos pos, IBlockState state, Random rand) {
        boolean gettingPower = isInputtingMechPower(world, pos);
        boolean isMechOn = isMechanicalOn(world, pos);
        boolean continuous = isTriggerMechanicalStateChange(world, pos);

        if (isMechOn != gettingPower) {
            if (continuous) {
                setTriggerMechanicalStateChange(world, pos, false);
                setMechanicalOn(world, pos, gettingPower);
                world.func_180497_b(pos, this, func_149738_a(world), 5);// world.markBlockForUpdate(pos);
                if (gettingPower) {
                    world.func_184133_a(null, pos, BWSounds.BELLOW, SoundCategory.BLOCKS, 0.7F, world.field_73012_v.nextFloat() * 0.25F + 2.5F);
                    blow(world, pos);
                }
                else {
                    world.func_184133_a(null, pos, BWSounds.BELLOW, SoundCategory.BLOCKS, 0.2F, world.field_73012_v.nextFloat() * 0.25F + 2.5F);
                }
                liftCollidingEntities(world, pos);
            } else {
                world.func_180497_b(pos, this, func_149738_a(world), 5);
                setTriggerMechanicalStateChange(world, pos, true);
            }
        } else if (continuous) {
            setTriggerMechanicalStateChange(world, pos, false);
        }
    }

    public boolean isTriggerMechanicalState(IBlockState state) {
        return state.func_177229_b(TRIGGER);
    }

    public boolean isTriggerMechanicalStateChange(IBlockAccess world, BlockPos pos) {
        return world.func_180495_p(pos).func_177229_b(TRIGGER);
    }

    public void setTriggerMechanicalStateChange(World world, BlockPos pos, boolean continuous) {
        world.func_175656_a(pos, world.func_180495_p(pos).func_177226_a(TRIGGER, continuous));
    }

    @Override
    public boolean canRotateOnTurntable(IBlockAccess world, BlockPos pos) {
        return true;
    }

    @Override
    public void rotateAroundYAxis(World world, BlockPos pos, boolean reverse) {
        if (DirUtils.rotateAroundY(this, world, pos, reverse)) {
            world.func_180497_b(pos, this, func_149738_a(world), 5);
            MechanicalUtil.destoryHorizontalAxles(world, pos);
            world.func_180497_b(pos, this, func_149738_a(world), 5);// world.markBlockForUpdate(pos);
        }
    }

    @Override
    public boolean canOutputMechanicalPower() {
        return false;
    }

    @Override
    public boolean canInputMechanicalPower() {
        return true;
    }

    @Override
    public boolean isInputtingMechPower(World world, BlockPos pos) {
        return MechanicalUtil.isBlockPoweredByAxle(world, pos, this);
    }

    @Override
    public boolean isOutputtingMechPower(World world, BlockPos pos) {
        return false;
    }

    @Override
    public boolean canInputPowerToSide(IBlockAccess world, BlockPos pos, EnumFacing dir) {
        EnumFacing facing = getFacingFromBlockState(world.func_180495_p(pos));
        return dir != facing && dir != EnumFacing.UP;
    }

    @Override
    public void overpower(World world, BlockPos pos) {
        breakBellows(world, pos);
    }

    @Override
    public boolean isMechanicalOn(IBlockAccess world, BlockPos pos) {
        return isMechanicalOnFromState(world.func_180495_p(pos));
    }

    @Override
    public void setMechanicalOn(World world, BlockPos pos, boolean isOn) {
        world.func_175656_a(pos, world.func_180495_p(pos).func_177226_a(ACTIVE, isOn));
    }

    @Override
    public boolean isMechanicalOnFromState(IBlockState state) {
        return state.func_177229_b(ACTIVE);
    }

    public void blow(World world, BlockPos pos) {
        if (isMechanicalOn(world, pos)) {
            stokeFlames(world, pos);
        }
    }

    public void playStateChangeSound(World world, BlockPos pos) {
        liftCollidingEntities(world, pos);
    }

    private void stokeFlames(World world, BlockPos pos) {
        EnumFacing dir = getFacingFromBlockState(world.func_180495_p(pos));
        EnumFacing dirLeft = DirUtils.rotateFacingAroundY(getFacingFromBlockState(world.func_180495_p(pos)), false);
        EnumFacing dirRight = DirUtils.rotateFacingAroundY(getFacingFromBlockState(world.func_180495_p(pos)), true);

        for (int i = 0; i < 3; i++) {
            BlockPos dirPos = pos.func_177967_a(dir, 1 + i);
            //
            Block target = world.func_180495_p(dirPos).func_177230_c();

            if (target == Blocks.field_150480_ab || target == BWMBlocks.STOKED_FLAME)
                stokeFire(world, dirPos);
            else if (!world.func_175623_d(dirPos))
                break;
            //
            BlockPos posLeft = dirPos.func_177972_a(dirLeft);

            Block targetLeft = world.func_180495_p(posLeft).func_177230_c();
            if (targetLeft == Blocks.field_150480_ab || targetLeft == BWMBlocks.STOKED_FLAME)
                stokeFire(world, posLeft);
            //
            BlockPos posRight = dirPos.func_177972_a(dirRight);

            Block targetRight = world.func_180495_p(posRight).func_177230_c();
            if (targetRight == Blocks.field_150480_ab || targetRight == BWMBlocks.STOKED_FLAME)
                stokeFire(world, posRight);
        }
    }

    private void stokeFire(World world, BlockPos pos) {
        BlockPos down = pos.func_177977_b();
        if (world.func_180495_p(down).func_177230_c() == BWMBlocks.HIBACHI) {
            int flag = (world.func_180495_p(pos).func_177230_c() == BWMBlocks.STOKED_FLAME) ? 4 : 3;
            world.func_180501_a(pos, BWMBlocks.STOKED_FLAME.func_176223_P(), flag);
        } else
            world.func_175698_g(pos);
    }

    private void liftCollidingEntities(World world, BlockPos pos) {
        int x = pos.func_177958_n();
        int y = pos.func_177956_o();
        int z = pos.func_177952_p();
        List<Entity> list = world.func_72872_a(Entity.class,
                new AxisAlignedBB(x, y + 0.6875F, z, x + 1, y + 1, z + 1));

        float extendedY = y + 1;

        if (list != null && list.size() > 0) {
            for (Entity entity : list) {
                if (!entity.field_70128_L && (entity.func_70104_M() || entity instanceof EntityItem)) {
                    double tempY = entity.func_174813_aQ().field_72338_b;

                    if (tempY < extendedY) {
                        double entityOffset = extendedY - tempY;
                        entity.func_70107_b(entity.field_70165_t, entity.field_70163_u + entityOffset, entity.field_70161_v);
                    }
                }
            }
        }
    }

    public void breakBellows(World world, BlockPos pos) {
        InvUtils.ejectStackWithOffset(world, pos, new ItemStack(Blocks.field_150376_bx, 2, 0));
        InvUtils.ejectStackWithOffset(world, pos, new ItemStack(BWMItems.MATERIAL, 1, 0));
        InvUtils.ejectStackWithOffset(world, pos, new ItemStack(BWMItems.MATERIAL, 2, 6));
        world.func_184133_a(null, pos, SoundEvents.field_187539_bB, SoundCategory.BLOCKS, 0.3F,
                world.field_73012_v.nextFloat() * 0.1F + 0.45F);
        world.func_175698_g(pos);
    }

    @Override
    public int func_176201_c(IBlockState state) {
        int meta = isMechanicalOnFromState(state) ? 8 : 0;
        meta += isTriggerMechanicalState(state) ? 4 : 0;
        return meta + state.func_177229_b(DirUtils.HORIZONTAL).func_176736_b();
    }

    @Override
    public IBlockState func_176203_a(int meta) {
        boolean isActive = false;
        if (meta > 7) {
            isActive = true;
            meta -= 8;
        }
        boolean isTrigger = meta > 3;
        if (isTrigger)
            meta -= 4;
        return this.func_176223_P().func_177226_a(ACTIVE, isActive).func_177226_a(TRIGGER, isTrigger)
                .func_177226_a(DirUtils.HORIZONTAL, EnumFacing.func_176731_b(meta));
    }

    @Override
    public BlockStateContainer func_180661_e() {
        return new BlockStateContainer(this, DirUtils.HORIZONTAL, ACTIVE, TRIGGER);
    }
}
