package betterwithmods.module.hardcore.hcbeacons;

import betterwithmods.common.BWRegistry;
import betterwithmods.common.blocks.BlockAesthetic;
import betterwithmods.common.items.tools.ItemSoulforgeArmor;
import betterwithmods.module.Feature;
import betterwithmods.util.player.PlayerHelper;
import com.google.common.collect.Maps;
import net.minecraft.block.state.IBlockState;
import net.minecraft.entity.EntityLivingBase;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.init.Blocks;
import net.minecraft.init.MobEffects;
import net.minecraft.potion.PotionEffect;
import net.minecraftforge.fml.common.event.FMLInitializationEvent;

import java.util.HashMap;

/**
 * Created by primetoxinz on 7/17/17.
 */
public class HCBeacons extends Feature {

    public static final HashMap<IBlockState, IBeaconEffect> BEACON_EFFECTS = Maps.newHashMap();

    @Override
    public void init(FMLInitializationEvent event) {
        BEACON_EFFECTS.put(Blocks.field_150359_w.func_176223_P(), (world, pos, level) -> {
        });
        BEACON_EFFECTS.put(Blocks.field_150339_S.func_176223_P(), (world, pos, level) -> {
            //TODO substitute ItemCompass.
        });
        BEACON_EFFECTS.put(Blocks.field_150475_bE.func_176223_P(), (world, pos, level) -> IBeaconEffect.forEachEntityAround(EntityLivingBase.class, world, pos, level, entity -> entity.func_70690_d(new PotionEffect(BWRegistry.POTION_LOOTING, 125, level - 1, true, false))));
        BEACON_EFFECTS.put(Blocks.field_150368_y.func_176223_P(), (world, pos, level) -> IBeaconEffect.forEachPlayersAround(world, pos, level, player -> player.func_70690_d(new PotionEffect(BWRegistry.POTION_TRUESIGHT, 125, 1))));
        BEACON_EFFECTS.put(Blocks.field_150484_ah.func_176223_P(), (world, pos, level) -> IBeaconEffect.forEachPlayersAround(world, pos, level, player -> player.func_70690_d(new PotionEffect(BWRegistry.POTION_FORTUNE, 125, level - 1))));
        BEACON_EFFECTS.put(Blocks.field_150426_aN.func_176223_P(), (world, pos, level) -> IBeaconEffect.forEachPlayersAround(world, pos, level, player -> player.func_70690_d(new PotionEffect(MobEffects.field_76439_r, 125, 1))));
        BEACON_EFFECTS.put(Blocks.field_150340_R.func_176223_P(), (world, pos, level) -> IBeaconEffect.forEachPlayersAround(world, pos, level, player -> player.func_70690_d(new PotionEffect(MobEffects.field_76422_e, 120, level))));
        BEACON_EFFECTS.put(Blocks.field_180399_cE.func_176223_P(), (world, pos, level) -> IBeaconEffect.forEachPlayersAround(world, pos, level, player -> player.func_70690_d(new PotionEffect(MobEffects.field_76430_j, 120, level))));
        BEACON_EFFECTS.put(BlockAesthetic.getVariant(BlockAesthetic.EnumType.DUNG), (world, pos, level) -> IBeaconEffect.forEachPlayersAround(world, pos, level, player -> {
                    if (!PlayerHelper.hasFullSet((EntityPlayer) player, ItemSoulforgeArmor.class)) {
                        player.func_70690_d(new PotionEffect(MobEffects.field_76436_u, 120, level));
                        player.func_70690_d(new PotionEffect(MobEffects.field_76431_k, 120, level));
                    }
                }
        ));
        BEACON_EFFECTS.put(Blocks.field_150402_ci.func_176223_P(), (world, pos, level) -> IBeaconEffect.forEachPlayersAround(world, pos, level, player -> {
                    if (!PlayerHelper.hasFullSet((EntityPlayer) player, ItemSoulforgeArmor.class)) {
                        player.func_70690_d(new PotionEffect(MobEffects.field_76440_q, 120, level));
                    }
                }
        ));
        BEACON_EFFECTS.put(BlockAesthetic.getVariant(BlockAesthetic.EnumType.HELLFIRE), (world, pos, level) -> IBeaconEffect.forEachPlayersAround(world, pos, level, player -> player.func_70690_d(new PotionEffect(MobEffects.field_76426_n, 120, level))));
        BEACON_EFFECTS.put(Blocks.field_180397_cI.func_176223_P(), (world, pos, level) -> IBeaconEffect.forEachPlayersAround(world, pos, level, player -> player.func_70690_d(new PotionEffect(MobEffects.field_76427_o, 120, level))));
        BEACON_EFFECTS.put(Blocks.field_150360_v.func_176223_P(), (world, pos, level) -> IBeaconEffect.forEachPlayersAround(world, pos, level, player -> player.func_70050_g(player.func_70086_ai() - 1)));
        BEACON_EFFECTS.put(BlockAesthetic.getVariant(BlockAesthetic.EnumType.STEEL), new SpawnBeaconEffect());
    }

    @Override
    public String getFeatureDescription() {
        return "Overhauls the function of Beacons. Beacons have extended range, no longer have a GUI, and require the same material throughout the pyramid. The pyramid material determines the beacon effect, and additional tiers increase the range and strength of the effects. Some beacon types may also cause side effects to occur while a beacon is active.";
    }
}
